## nodejs 4.6.1~dfsg

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www

OSTYPE := $(shell uname -s | tr '[A-Z]' '[a-z]')

ifdef QUICKCHECK
  QUICKCHECK_ARG := --quickcheck
endif

ifdef ENABLE_V8_TAP
  TAP_V8 := --junitout $(PWD)/v8-tap.xml
  TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
  TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
endif

ifdef DISABLE_V8_I18N
  V8_TEST_NO_I18N := --noi18n
  V8_BUILD_OPTIONS += i18nsupport=off
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[A-Z]' '[a-z]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
NODE ?= ./$(NODE_EXE)
NODE_G_EXE = node_g$(EXEEXT)

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=small-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to verbose builds.
# To do quiet/pretty builds, run `make V=` to set V to an empty string,
# or set the V environment variable to an empty string.
V ?= 1

# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: out/Makefile $(NODE_EXE)
else
all: out/Makefile $(NODE_EXE) $(NODE_G_EXE)
endif

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

$(NODE_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Release V=$(V)
	ln -fs out/Release/$(NODE_EXE) $@

$(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Debug V=$(V)
	ln -fs out/Debug/$(NODE_EXE) $@

out/Makefile: common.gypi deps/uv/uv.gyp deps/http_parser/http_parser.gyp deps/zlib/zlib.gyp deps/v8/build/toolchain.gypi deps/v8/build/features.gypi deps/v8/tools/gyp/v8.gyp node.gyp config.gypi
	$(PYTHON) tools/gyp_node.py -f make

config.gypi: configure
	if [ -f $@ ]; then
		$(error Stale $@, please re-run ./configure)
	else
		$(error No $@, please run ./configure first)
	fi

install: all
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

uninstall:
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

clean:
	-rm -rf out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE)
	@if [ -d out ]; then find out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs rm -rf; fi
	-rm -rf node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; rm -rf deps/icu; fi
	-rm -f test.tap

distclean:
	-rm -rf out
	-rm -f config.gypi icu_config.gypi config_fips.gypi
	-rm -f config.mk
	-rm -rf $(NODE_EXE) $(NODE_G_EXE)
	-rm -rf node_modules
	-rm -rf deps/icu
	-rm -rf deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	-rm -f $(BINARYTAR).* $(TARBALL).*
	-rm -rf deps/v8/testing/gmock
	-rm -rf deps/v8/testing/gtest

check: test

cctest: all
	@out/$(BUILDTYPE)/$@

v8:
	tools/make-v8.sh v8
	$(MAKE) -C deps/v8 $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

test: | cctest  # Depends on 'all'.
	$(PYTHON) tools/test.py --mode=release doctool message pseudo-tty parallel sequential -J
	$(MAKE) jslint
	$(MAKE) cpplint

test-parallel: all
	$(PYTHON) tools/test.py --mode=release parallel -J

test-valgrind: all
	$(PYTHON) tools/test.py --mode=release --valgrind sequential parallel message

test/gc/node_modules/weak/build/Release/weakref.node: $(NODE_EXE)
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/test/gc/node_modules/weak" \
		--nodedir="$(shell pwd)"

# Implicitly depends on $(NODE_EXE), see the build-addons rule for rationale.
test/addons/.docbuildstamp: tools/doc/addon-verify.js doc/api/addons.md
	$(RM) -r test/addons/??_*/
	$(NODE) $<
	touch $@

ADDONS_BINDING_GYPS := \
	$(filter-out test/addons/??_*/binding.gyp, \
		$(wildcard test/addons/*/binding.gyp))

# Implicitly depends on $(NODE_EXE), see the build-addons rule for rationale.
# Depends on node-gyp package.json so that build-addons is (re)executed when
# node-gyp is updated as part of an npm update.
test/addons/.buildstamp: deps/npm/node_modules/node-gyp/package.json \
	$(ADDONS_BINDING_GYPS) test/addons/.docbuildstamp
	# Cannot use $(wildcard test/addons/*/) here, it's evaluated before
	# embedded addons have been generated from the documentation.
	for dirname in test/addons/*/; do \
		$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
			--python="$(PYTHON)" \
			--directory="$$PWD/$$dirname" \
			--nodedir="$$PWD"; \
	done
	touch $@

# .buildstamp and .docbuildstamp need $(NODE_EXE) but cannot depend on it
# directly because it calls make recursively.  The parent make cannot know
# if the subprocess touched anything so it pessimistically assumes that
# .buildstamp and .docbuildstamp are out of date and need a rebuild.
# Just goes to show that recursive make really is harmful...
# TODO(bnoordhuis) Force rebuild after gyp update.
build-addons: $(NODE_EXE) test/addons/.buildstamp

test-gc: all test/gc/node_modules/weak/build/Release/weakref.node
	$(PYTHON) tools/test.py --mode=release gc

test-build: | all build-addons

test-all: test-build test/gc/node_modules/weak/build/Release/weakref.node
	$(PYTHON) tools/test.py --mode=debug,release

test-all-valgrind: test-build
	$(PYTHON) tools/test.py --mode=debug,release --valgrind

CI_NATIVE_SUITES := addons
CI_JS_SUITES := doctool message parallel pseudo-tty sequential

# Build and test addons without building anything else
test-ci-native: | test/addons/.buildstamp
	$(PYTHON) tools/test.py -p tap --logfile test.tap \
		--mode=release --flaky-tests=$(FLAKY_TESTS) \
		$(TEST_CI_ARGS) $(CI_NATIVE_SUITES)

# This target should not use a native compiler at all
test-ci-js:
	$(PYTHON) tools/test.py -p tap --logfile test.tap \
		--mode=release --flaky-tests=$(FLAKY_TESTS) \
		$(TEST_CI_ARGS) $(CI_JS_SUITES)

test-ci: | build-addons
	$(PYTHON) tools/test.py -p tap --logfile test.tap --mode=release --flaky-tests=$(FLAKY_TESTS) \
		$(TEST_CI_ARGS) $(CI_NATIVE_SUITES) $(CI_JS_SUITES)

test-release: test-build
	$(PYTHON) tools/test.py --mode=release

test-debug: test-build
	$(PYTHON) tools/test.py --mode=debug

test-message: test-build
	$(PYTHON) tools/test.py message

test-simple: | cctest  # Depends on 'all'.
	$(PYTHON) tools/test.py parallel sequential

test-pummel: all
	$(PYTHON) tools/test.py pummel

test-internet: all
	$(PYTHON) tools/test.py internet

test-debugger: all
	$(PYTHON) tools/test.py debugger

test-known-issues: all
	$(PYTHON) tools/test.py known_issues --expect-fail

test-npm: $(NODE_EXE)
	NODE=$(NODE) tools/test-npm.sh

test-npm-publish: $(NODE_EXE)
	npm_package_config_publishtest=true $(NODE) deps/npm/test/run.js

test-addons: test-build
	$(PYTHON) tools/test.py --mode=release addons

test-timers:
	$(MAKE) --directory=tools faketime
	$(PYTHON) tools/test.py --mode=release timers

test-timers-clean:
	$(MAKE) --directory=tools clean

test-v8: v8
	# note: performs full test unless QUICKCHECK is specified
	deps/v8/tools/run-tests.py --arch=$(V8_ARCH) \
        --mode=$(BUILDTYPE_LOWER) $(V8_TEST_NO_I18N) $(QUICKCHECK_ARG) \
        --no-presubmit \
        --shell-dir=$(PWD)/deps/v8/out/$(V8_ARCH).$(BUILDTYPE_LOWER) \
	 $(TAP_V8)

test-v8-intl: v8
	# note: performs full test unless QUICKCHECK is specified
	deps/v8/tools/run-tests.py --arch=$(V8_ARCH) \
        --mode=$(BUILDTYPE_LOWER) --no-presubmit $(QUICKCHECK_ARG) \
        --shell-dir=deps/v8/out/$(V8_ARCH).$(BUILDTYPE_LOWER) intl \
        $(TAP_V8_INTL)

test-v8-benchmarks: v8
	deps/v8/tools/run-tests.py --arch=$(V8_ARCH) --mode=$(BUILDTYPE_LOWER) \
        --download-data $(QUICKCHECK_ARG) --no-presubmit \
        --shell-dir=deps/v8/out/$(V8_ARCH).$(BUILDTYPE_LOWER) benchmarks \
	 $(TAP_V8_BENCHMARKS)

test-v8-all: test-v8 test-v8-intl test-v8-benchmarks
	# runs all v8 tests

apidoc_sources = $(wildcard doc/api/*.md)
apidocs = $(addprefix out/,$(apidoc_sources:.md=.html)) \
		$(addprefix out/,$(apidoc_sources:.md=.json))

apidoc_dirs = out/doc out/doc/api/ out/doc/api/assets

apiassets = $(subst api_assets,api/assets,$(addprefix out/,$(wildcard doc/api_assets/*)))

doc-only: $(apidoc_dirs) $(apiassets) $(apidocs) tools/doc/

doc: $(NODE_EXE) doc-only

$(apidoc_dirs):
	mkdir -p $@

out/doc/api/assets/%: doc/api_assets/% out/doc/api/assets/
	cp $< $@

out/doc/%: doc/%
	cp -r $< $@

# check if ./node is actually set, else use user pre-installed binary
gen-json = tools/doc/generate.js --format=json $< > $@
out/doc/api/%.json: doc/api/%.md
	[ -x $(NODE) ] && $(NODE) $(gen-json) || node $(gen-json)

# check if ./node is actually set, else use user pre-installed binary
gen-html = tools/doc/generate.js --node-version=$(FULLVERSION) --format=html --template=doc/template.html $< > $@
out/doc/api/%.html: doc/api/%.md
	[ -x $(NODE) ] && $(NODE) $(gen-html) || node $(gen-html)

docopen: out/doc/api/all.html
	-google-chrome out/doc/api/all.html

docclean:
	-rm -rf out/doc

build-ci:
	$(PYTHON) ./configure $(CONFIG_FLAGS)
	$(MAKE)

run-ci: build-ci
	$(MAKE) test-ci

RAWVER=$(shell $(PYTHON) tools/getnodeversion.py)
VERSION=v$(RAWVER)

# For nightly builds, you must set DISTTYPE to "nightly", "next-nightly" or
# "custom". For the nightly and next-nightly case, you need to set DATESTRING
# and COMMIT in order to properly name the build.
# For the rc case you need to set CUSTOMTAG to an appropriate CUSTOMTAG number

ifndef DISTTYPE
DISTTYPE=release
endif
ifeq ($(DISTTYPE),release)
FULLVERSION=$(VERSION)
else # ifeq ($(DISTTYPE),release)
ifeq ($(DISTTYPE),custom)
ifndef CUSTOMTAG
$(error CUSTOMTAG is not set for DISTTYPE=custom)
endif # ifndef CUSTOMTAG
TAG=$(CUSTOMTAG)
else # ifeq ($(DISTTYPE),custom)
ifndef DATESTRING
$(error DATESTRING is not set for nightly)
endif # ifndef DATESTRING
ifndef COMMIT
$(error COMMIT is not set for nightly)
endif # ifndef COMMIT
ifneq ($(DISTTYPE),nightly)
ifneq ($(DISTTYPE),next-nightly)
$(error DISTTYPE is not release, custom, nightly or next-nightly)
endif # ifneq ($(DISTTYPE),next-nightly)
endif # ifneq ($(DISTTYPE),nightly)
TAG=$(DISTTYPE)$(DATESTRING)$(COMMIT)
endif # ifeq ($(DISTTYPE),custom)
FULLVERSION=$(VERSION)-$(TAG)
endif # ifeq ($(DISTTYPE),release)

DISTTYPEDIR ?= $(DISTTYPE)
RELEASE=$(shell sed -ne 's/\#define NODE_VERSION_IS_RELEASE \([01]\)/\1/p' src/node_version.h)
PLATFORM=$(shell uname | tr '[:upper:]' '[:lower:]')
NPMVERSION=v$(shell cat deps/npm/package.json | grep '"version"' | sed 's/^[^:]*: "\([^"]*\)",.*/\1/')

UNAME_M=$(shell uname -m)
ifeq ($(findstring x86_64,$(UNAME_M)),x86_64)
DESTCPU ?= x64
else
ifeq ($(findstring ppc64,$(UNAME_M)),ppc64)
DESTCPU ?= ppc64
else
ifeq ($(findstring ppc,$(UNAME_M)),ppc)
DESTCPU ?= ppc
else
ifeq ($(findstring s390x,$(UNAME_M)),s390x)
DESTCPU ?= s390x
else
ifeq ($(findstring s390,$(UNAME_M)),s390)
DESTCPU ?= s390
else
ifeq ($(findstring arm,$(UNAME_M)),arm)
DESTCPU ?= arm
else
ifeq ($(findstring aarch64,$(UNAME_M)),aarch64)
DESTCPU ?= aarch64
else
ifeq ($(findstring powerpc,$(shell uname -p)),powerpc)
DESTCPU ?= ppc64
else
DESTCPU ?= x86
endif
endif
endif
endif
endif
endif
endif
endif
ifeq ($(DESTCPU),x64)
ARCH=x64
else
ifeq ($(DESTCPU),arm)
ARCH=arm
else
ifeq ($(DESTCPU),aarch64)
ARCH=arm64
else
ifeq ($(DESTCPU),ppc64)
ARCH=ppc64
else
ifeq ($(DESTCPU),ppc)
ARCH=ppc
else
ifeq ($(DESTCPU),s390)
ARCH=s390
else
ifeq ($(DESTCPU),s390x)
ARCH=s390x
else
ARCH=x86
endif
endif
endif
endif
endif
endif
endif

# node and v8 use different arch names (e.g. node 'x86' vs v8 'ia32').
# pass the proper v8 arch name to $V8_ARCH based on user-specified $DESTCPU.
ifeq ($(DESTCPU),x86)
V8_ARCH=ia32
else
V8_ARCH ?= $(DESTCPU)

endif

# enforce "x86" over "ia32" as the generally accepted way of referring to 32-bit intel
ifeq ($(ARCH),ia32)
override ARCH=x86
endif
ifeq ($(DESTCPU),ia32)
override DESTCPU=x86
endif

TARNAME=node-$(FULLVERSION)
TARBALL=$(TARNAME).tar
BINARYNAME=$(TARNAME)-$(PLATFORM)-$(ARCH)
BINARYTAR=$(BINARYNAME).tar

=== debian/changelog ===
nodejs (4.6.1~dfsg-1) unstable; urgency=medium

  * test-regress-GH-746 moved from sequential to parallel
  * New upstream version 4.6.1~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Tue, 18 Oct 2016 20:51:52 +0200

nodejs (4.6.0~dfsg-3) unstable; urgency=medium

  * Restore flakyness of parallel/test-regress-GH-746.
    Closes: #841199.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 18 Oct 2016 15:29:36 +0200

nodejs (4.6.0~dfsg-2) unstable; urgency=medium

  * Skip two more tests accessing network
  * Remove licensecheck from b-d to avoid double call

 -- Jérémy Lal <kapouer@melix.org>  Thu, 13 Oct 2016 09:29:17 +0200

nodejs (4.6.0~dfsg-1) unstable; urgency=medium

  * New upstream version 4.6.0~dfsg
    Fixes: CVE-2016-7099, CVE-2016-5325
    Closes: #839714.
  * Hardening flags: +all, -pie because v8 doesn't support pie.
  * Disable DNS during tests, using RES_OPTIONS=attempts:0,
    and disable tests that fail to run when only a loopback
    interface is available. Closes: #830242.
  * Do not fail when node symlink exists in check target
  * Disable addons, pseudo-tty, doctool test suites
  * test_ci patch: allow overriding CI test options
  * Disable tests failing without DNS
  * doctool-yaml patch: avoid use of eslint deps and use
    node-yamlish package instead
  * Build-Depends node-marked, exclude it for convenience,
  * Stop building for powerpc architecture as some cpu are not
    actually supported by libv8. Closes: #836415.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 09 Oct 2016 22:05:40 +0200

nodejs (4.4.7~dfsg-2) unstable; urgency=medium

  * Target mips r2 instead of loongson

 -- Jérémy Lal <kapouer@melix.org>  Sun, 03 Jul 2016 16:08:55 +0200

nodejs (4.4.7~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.7~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Fri, 01 Jul 2016 01:36:36 +0200

nodejs (4.4.6~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.6~dfsg
  * Update s390 patch

 -- Jérémy Lal <kapouer@melix.org>  Fri, 24 Jun 2016 02:03:08 +0200

nodejs (4.4.5~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.5~dfsg
  * Standards-Version 3.9.8
  * Ensure it fails on armel (Closes: #818552)
  * Build-Depends openssl 1.0.2 (Closes: #821403)

 -- Jérémy Lal <kapouer@melix.org>  Wed, 22 Jun 2016 21:46:13 +0200

nodejs (4.4.3~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.3~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Fri, 15 Apr 2016 18:01:42 +0200

nodejs (4.4.2~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.2~dfsg
  * Document s390 maintenance for Node.js 4.x LTS
  * Update s390 patch, update upstream url for that patch
  * Expect test-npm-install to fail

 -- Jérémy Lal <kapouer@melix.org>  Wed, 06 Apr 2016 10:34:06 +0200

nodejs (4.4.1~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.1~dfsg
  * Import upstream v8z s390 patches

 -- Jérémy Lal <kapouer@melix.org>  Wed, 23 Mar 2016 23:10:36 +0100

nodejs (4.4.0~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.4.0~dfsg
  * watch: minor updates can actually happen on LTS
  * copyright: update file path for v8 prof polyfill
  * Standards-Version 3.9.7
  * Use secure VCS fields

 -- Jérémy Lal <kapouer@melix.org>  Wed, 09 Mar 2016 23:27:34 +0100

nodejs (4.3.1~dfsg-3) unstable; urgency=medium

  * Patch configure script to allow and default to x87 on i386.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 29 Feb 2016 08:55:51 +0100

nodejs (4.3.1~dfsg-2) unstable; urgency=medium

  * i386 port supports cpu that do not have sse2; those cpu are
    targeted by the v8 x87 port. Closes: #815983.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 29 Feb 2016 00:54:21 +0100

nodejs (4.3.1~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.3.1~dfsg
  * Update s390 branch, add an upstream patch

 -- Jérémy Lal <kapouer@melix.org>  Wed, 17 Feb 2016 14:00:00 +0100

nodejs (4.3.0~dfsg-2) unstable; urgency=medium

  * Fix lintian override for binary fixtures

 -- Jérémy Lal <kapouer@melix.org>  Wed, 10 Feb 2016 02:14:14 +0100

nodejs (4.3.0~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.3.0~dfsg, no ABI change.
  * Import latest patches from v8 4.5-s390 branch
  * Use master-lts/upstream-lts naming scheme
  * Watch 4.3.x versions
  * Override lintian error for two binary (but trivial) fixtures.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 10 Feb 2016 00:50:44 +0100

=== debian/control ===
Source: nodejs
Section: web
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 binutils,
 openssl (>= 1.0.2),
 pkg-config,
 bash-completion,
 curl,
 procps,
 zlib1g-dev,
 libicu-dev,
 libkvm-dev [kfreebsd-any],
 gyp (>= 0.1~svn1773),
 node-yamlish,
 node-marked,
 python,
 libssl-dev (>= 1.0.2),
 libuv1-dev,
 ca-certificates
Standards-Version: 3.9.8
Homepage: http://nodejs.org/
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/nodejs.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/nodejs.git
Testsuite: autopkgtest

Package: nodejs-dev
Section: devel
Priority: extra
Architecture: any
Depends: ${cdbs:Depends},
 ${misc:Depends},
 nodejs (= ${binary:Version})
Suggests: ${cdbs:Suggests}
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package is needed to build plugins.

Package: nodejs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Provides: ${cdbs:Provides}
Description: evented I/O for V8 javascript
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: nodejs-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends},
 nodejs (= ${binary:Version})
Description: evented I/O for V8 javascript (debug)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package contains the debugging symbols.

Package: nodejs-legacy
Priority: extra
Architecture: all
Depends: ${misc:Depends},
 nodejs (>= 0.6.19~dfsg1-3~)
Conflicts: node
Description: evented I/O for V8 javascript (legacy symlink)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package contains a symlink for legacy Node.js code requiring
 binary to be /usr/bin/node (not /usr/bin/nodejs as provided in Debian).
 .
 No other Debian packages should depend on this package.  For more
 information, see
 <http://lists.debian.org/debian-devel-announce/2012/07/msg00002.html>

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

# recent OpenSSL needed because https://github.com/nodejs/node/issues/589
ssl-minver = 1.0.2

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
abi := $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)
abi-deps = nodejs-dev (>= $(DEB_VERSION)~), nodejs-abi-$(abi)

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper

# Needed by upstream build
#  * recent gyp needed to build using flock
bdeps = binutils, openssl (>= $(ssl-minver)), pkg-config
bdeps +=, bash-completion, curl, procps, zlib1g-dev, libicu-dev
bdeps +=, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
# needed by doctool-yaml.patch
bdeps +=, node-yamlish
# needed by doc builder
bdeps +=, node-marked

# Needed by upstream build and binary development package
#  * recent libv8 because... FIXME (git commit eb490ef)
deps = python, libssl-dev (>= $(ssl-minver))
deps +=, libuv1-dev, ca-certificates

CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps)
CDBS_DEPENDS_nodejs-dev = $(deps)
CDBS_PROVIDES_nodejs = nodejs-abi-$(abi)

# suppress checking binary files, to not upset dpkg-source
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(deps/v8/benchmarks/v8-logo\.png|test/fixtures/person\.jpg.*|src/res/node\.ico|debian/(changelog|copyright(|_hints|_newhints)))$

DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = --without-npm --shared-openssl --shared-zlib --shared-libuv --with-intl=system-icu --prefix=/usr

# map HOST ARCH AND OS, and if unknown let upstream guess

# ia32 x64 x32 arm arm64 mips mipsel mips64el x87 ppc ppc64
destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),x87))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),x87))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),x87))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu, see https://github.com/paul99/v8m-rb/issues/192
# and https://bugs.debian.org/800410

# https://lists.debian.org/debian-mips/2016/07/msg00005.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian defaults
# v8 does not support < armv5
CXXFLAGS += -march=armv5t
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/test/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_NATIVE_SUITES =
export CI_JS_SUITES = message parallel sequential

# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci

# hardening gyp
CXXFLAGS+=$(CPPFLAGS)
export CXXFLAGS
export LDFLAGS

# disable DNS requests during tests
export RES_OPTIONS = attempts:0

# properly clean files from build, test, python
clean::
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f test/fixtures/hello.txt
	rm -rf test/tmp*
	find . -name "*.pyc" -delete
	rm -rf out

binary-post-install/nodejs::
	mv debian/nodejs/usr/bin/node debian/nodejs/usr/bin/nodejs
	mv debian/nodejs/usr/share/man/man1/node.1 debian/nodejs/usr/share/man/man1/nodejs.1

# remove *.json files from documentation
binary-install/nodejs::
	find debian/nodejs/usr/share/doc/nodejs -name *.json -delete

pre-build::
	mkdir -p $(HOME)

build/nodejs::
	make doc

# Provide dependency hints for reverse dependencies to consume
CDBS_SUGGESTS_nodejs-dev = debhelper
install/nodejs-dev::
	pod2man --release "" --center "" debian/dh_nodejs > $(cdbs_curdestdir)/usr/share/man/man1/dh_nodejs.1
	install -D debian/dh_nodejs $(cdbs_curdestdir)/usr/bin/dh_nodejs
	mkdir -p $(cdbs_curdestdir)/usr/share/nodejs
	echo '$(abi-deps)' > $(cdbs_curdestdir)/usr/share/nodejs/pluginsdep

check:
	-ln -s /usr/bin/nodejs node
	mkdir -p $(HOME)
	make $(DEB_MAKE_CHECK_TARGET)
	rm -f node
	rm -rf test/tmp*

## nodejs 4.7.2~dfsg

=== Makefile ===
--- 
+++ 
@@ -8,6 +8,7 @@
 FLAKY_TESTS ?= run
 TEST_CI_ARGS ?=
 STAGINGSERVER ?= node-www
+LOGLEVEL ?= silent
 
 OSTYPE := $(shell uname -s | tr '[A-Z]' '[a-z]')
 
@@ -35,6 +36,7 @@
 NODE_EXE = node$(EXEEXT)
 NODE ?= ./$(NODE_EXE)
 NODE_G_EXE = node_g$(EXEEXT)
+NPM ?= ./deps/npm/bin/npm-cli.js
 
 # Flags for packaging.
 BUILD_DOWNLOAD_FLAGS ?= --download=all
@@ -70,11 +72,7 @@
 	$(PYTHON) tools/gyp_node.py -f make
 
 config.gypi: configure
-	if [ -f $@ ]; then
-		$(error Stale $@, please re-run ./configure)
-	else
-		$(error No $@, please run ./configure first)
-	fi
+	$(error Missing or stale $@, please run ./$<)
 
 install: all
 	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'
@@ -83,7 +81,8 @@
 	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'
 
 clean:
-	-rm -rf out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE)
+	-rm -rf out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
+                out/$(BUILDTYPE)/node.exp
 	@if [ -d out ]; then find out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs rm -rf; fi
 	-rm -rf node_modules
 	@if [ -d deps/icu ]; then echo deleting deps/icu; rm -rf deps/icu; fi
@@ -107,7 +106,7 @@
 	@out/$(BUILDTYPE)/$@
 
 v8:
-	tools/make-v8.sh v8
+	tools/make-v8.sh
 	$(MAKE) -C deps/v8 $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)
 
 test: | cctest  # Depends on 'all'.
@@ -128,7 +127,13 @@
 		--nodedir="$(shell pwd)"
 
 # Implicitly depends on $(NODE_EXE), see the build-addons rule for rationale.
-test/addons/.docbuildstamp: tools/doc/addon-verify.js doc/api/addons.md
+DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.js doc/api/addons.md
+
+ifeq ($(OSTYPE),aix)
+DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
+endif
+
+test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS)
 	$(RM) -r test/addons/??_*/
 	$(NODE) $<
 	touch $@
@@ -140,12 +145,15 @@
 # Implicitly depends on $(NODE_EXE), see the build-addons rule for rationale.
 # Depends on node-gyp package.json so that build-addons is (re)executed when
 # node-gyp is updated as part of an npm update.
-test/addons/.buildstamp: deps/npm/node_modules/node-gyp/package.json \
+test/addons/.buildstamp: config.gypi \
+	deps/npm/node_modules/node-gyp/package.json \
 	$(ADDONS_BINDING_GYPS) test/addons/.docbuildstamp
-	# Cannot use $(wildcard test/addons/*/) here, it's evaluated before
-	# embedded addons have been generated from the documentation.
-	for dirname in test/addons/*/; do \
-		$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
+#	Cannot use $(wildcard test/addons/*/) here, it's evaluated before
+#	embedded addons have been generated from the documentation.
+	@for dirname in test/addons/*/; do \
+		echo "\nBuilding addon $$PWD/$$dirname" ; \
+		env MAKEFLAGS="-j1" $(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp \
+		        --loglevel=$(LOGLEVEL) rebuild \
 			--python="$(PYTHON)" \
 			--directory="$$PWD/$$dirname" \
 			--nodedir="$$PWD"; \
@@ -175,6 +183,7 @@
 CI_JS_SUITES := doctool message parallel pseudo-tty sequential
 
 # Build and test addons without building anything else
+test-ci-native: LOGLEVEL := info
 test-ci-native: | test/addons/.buildstamp
 	$(PYTHON) tools/test.py -p tap --logfile test.tap \
 		--mode=release --flaky-tests=$(FLAKY_TESTS) \
@@ -186,7 +195,9 @@
 		--mode=release --flaky-tests=$(FLAKY_TESTS) \
 		$(TEST_CI_ARGS) $(CI_JS_SUITES)
 
+test-ci: LOGLEVEL := info
 test-ci: | build-addons
+	out/Release/cctest --gtest_output=tap:cctest.tap
 	$(PYTHON) tools/test.py -p tap --logfile test.tap --mode=release --flaky-tests=$(FLAKY_TESTS) \
 		$(TEST_CI_ARGS) $(CI_NATIVE_SUITES) $(CI_JS_SUITES)
 
@@ -231,7 +242,7 @@
 	$(MAKE) --directory=tools clean
 
 test-v8: v8
-	# note: performs full test unless QUICKCHECK is specified
+#	note: performs full test unless QUICKCHECK is specified
 	deps/v8/tools/run-tests.py --arch=$(V8_ARCH) \
         --mode=$(BUILDTYPE_LOWER) $(V8_TEST_NO_I18N) $(QUICKCHECK_ARG) \
         --no-presubmit \
@@ -239,7 +250,7 @@
 	 $(TAP_V8)
 
 test-v8-intl: v8
-	# note: performs full test unless QUICKCHECK is specified
+#	note: performs full test unless QUICKCHECK is specified
 	deps/v8/tools/run-tests.py --arch=$(V8_ARCH) \
         --mode=$(BUILDTYPE_LOWER) --no-presubmit $(QUICKCHECK_ARG) \
         --shell-dir=deps/v8/out/$(V8_ARCH).$(BUILDTYPE_LOWER) intl \
@@ -252,18 +263,17 @@
 	 $(TAP_V8_BENCHMARKS)
 
 test-v8-all: test-v8 test-v8-intl test-v8-benchmarks
-	# runs all v8 tests
+# runs all v8 tests
 
 apidoc_sources = $(wildcard doc/api/*.md)
-apidocs = $(addprefix out/,$(apidoc_sources:.md=.html)) \
-		$(addprefix out/,$(apidoc_sources:.md=.json))
+apidocs_html = $(apidoc_dirs) $(apiassets) $(addprefix out/,$(apidoc_sources:.md=.html))
+apidocs_json = $(apidoc_dirs) $(apiassets) $(addprefix out/,$(apidoc_sources:.md=.json))
 
 apidoc_dirs = out/doc out/doc/api/ out/doc/api/assets
 
 apiassets = $(subst api_assets,api/assets,$(addprefix out/,$(wildcard doc/api_assets/*)))
 
-doc-only: $(apidoc_dirs) $(apiassets) $(apidocs) tools/doc/
-
+doc-only: $(apidocs_html) $(apidocs_json)
 doc: $(NODE_EXE) doc-only
 
 $(apidoc_dirs):
@@ -278,15 +288,29 @@
 # check if ./node is actually set, else use user pre-installed binary
 gen-json = tools/doc/generate.js --format=json $< > $@
 out/doc/api/%.json: doc/api/%.md
+	@[ -e tools/doc/node_modules/js-yaml/package.json ] || \
+		[ -e tools/eslint/node_modules/js-yaml/package.json ] || \
+		if [ -x $(NODE) ]; then \
+			cd tools/doc && ../../$(NODE) ../../$(NPM) install; \
+		else \
+			cd tools/doc && node ../../$(NPM) install; \
+		fi
 	[ -x $(NODE) ] && $(NODE) $(gen-json) || node $(gen-json)
 
 # check if ./node is actually set, else use user pre-installed binary
 gen-html = tools/doc/generate.js --node-version=$(FULLVERSION) --format=html --template=doc/template.html $< > $@
 out/doc/api/%.html: doc/api/%.md
+	@[ -e tools/doc/node_modules/js-yaml/package.json ] || \
+		[ -e tools/eslint/node_modules/js-yaml/package.json ] || \
+		if [ -x $(NODE) ]; then \
+			cd tools/doc && ../../$(NODE) ../../$(NPM) install; \
+		else \
+			cd tools/doc && node ../../$(NPM) install; \
+		fi
 	[ -x $(NODE) ] && $(NODE) $(gen-html) || node $(gen-html)
 
-docopen: out/doc/api/all.html
-	-google-chrome out/doc/api/all.html
+docopen: $(apidocs_html)
+	@$(PYTHON) -mwebbrowser file://$(PWD)/out/doc/api/all.html
 
 docclean:
 	-rm -rf out/doc
@@ -361,66 +385,3 @@
 ifeq ($(findstring aarch64,$(UNAME_M)),aarch64)
 DESTCPU ?= aarch64
 else
-ifeq ($(findstring powerpc,$(shell uname -p)),powerpc)
-DESTCPU ?= ppc64
-else
-DESTCPU ?= x86
-endif
-endif
-endif
-endif
-endif
-endif
-endif
-endif
-ifeq ($(DESTCPU),x64)
-ARCH=x64
-else
-ifeq ($(DESTCPU),arm)
-ARCH=arm
-else
-ifeq ($(DESTCPU),aarch64)
-ARCH=arm64
-else
-ifeq ($(DESTCPU),ppc64)
-ARCH=ppc64
-else
-ifeq ($(DESTCPU),ppc)
-ARCH=ppc
-else
-ifeq ($(DESTCPU),s390)
-ARCH=s390
-else
-ifeq ($(DESTCPU),s390x)
-ARCH=s390x
-else
-ARCH=x86
-endif
-endif
-endif
-endif
-endif
-endif
-endif
-
-# node and v8 use different arch names (e.g. node 'x86' vs v8 'ia32').
-# pass the proper v8 arch name to $V8_ARCH based on user-specified $DESTCPU.
-ifeq ($(DESTCPU),x86)
-V8_ARCH=ia32
-else
-V8_ARCH ?= $(DESTCPU)
-
-endif
-
-# enforce "x86" over "ia32" as the generally accepted way of referring to 32-bit intel
-ifeq ($(ARCH),ia32)
-override ARCH=x86
-endif
-ifeq ($(DESTCPU),ia32)
-override DESTCPU=x86
-endif
-
-TARNAME=node-$(FULLVERSION)
-TARBALL=$(TARNAME).tar
-BINARYNAME=$(TARNAME)-$(PLATFORM)-$(ARCH)
-BINARYTAR=$(BINARYNAME).tar

=== debian/changelog ===
nodejs (4.7.2~dfsg-1ubuntu3) zesty; urgency=medium

  * Disable test-process-config because it needs configured tree

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 12 Feb 2017 08:42:42 +0200

nodejs (4.7.2~dfsg-1ubuntu2) zesty; urgency=medium

  * Make sure we don't try to build for ppc64 on powerpc

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 09 Feb 2017 11:24:53 +0200

nodejs (4.7.2~dfsg-1ubuntu1) zesty; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Add debian/patches/fix_sslv3_test.patch:
      properly handle how SSLv3 was disabled in openssl
  * Enable building for powerpc architecture again

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 08 Feb 2017 16:52:42 +0200

nodejs (4.7.2~dfsg-1) unstable; urgency=medium

  * New upstream version 4.7.2~dfsg
  * Build-Depend libssl1.0-dev (Closes: #828457)
  * Patch tests to pass with openssl 1.1.0 cli
  * Patch doc build target to avoid remote download
  * Update test_ci_buildd patch to run test-ci-js suite
  * Recommends ca-certificates
  * Fix recursive dependency on node-yamlish/marked (Closes: #850082)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 06 Jan 2017 01:25:51 +0100

nodejs (4.6.1~dfsg-1ubuntu1) zesty; urgency=medium

  * Sync with Debian. Remaining change:
    - Add debian/patches/fix_sslv3_test.patch:
      properly handle how SSLv3 was disabled in openssl.

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 20 Dec 2016 23:02:48 -0500

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: nodejs
 Section: web
-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>,
  Jonas Smedegaard <dr@jones.dk>
 Build-Depends: cdbs,
- debhelper,
+ debhelper (>=9.20141010),
  dh-buildinfo,
  binutils,
  openssl (>= 1.0.2),
@@ -16,12 +17,12 @@
  libicu-dev,
  libkvm-dev [kfreebsd-any],
  gyp (>= 0.1~svn1773),
- node-yamlish,
- node-marked,
+ ca-certificates,
+ node-yamlish <!stage1>,
+ node-marked <!stage1>,
  python,
- libssl-dev (>= 1.0.2),
- libuv1-dev,
- ca-certificates
+ libssl1.0-dev (>= 1.0.2),
+ libuv1-dev
 Standards-Version: 3.9.8
 Homepage: http://nodejs.org/
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/nodejs.git
@@ -51,6 +52,7 @@
 Depends: ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${cdbs:Provides}
+Recommends: ${cdbs:Recommends}
 Description: evented I/O for V8 javascript
  Node.js is a platform built on Chrome's JavaScript runtime for easily
  building fast, scalable network applications. Node.js uses an

=== debian/rules ===
--- 
+++ 
@@ -15,25 +15,29 @@
 
 # Build-depend unversioned on debhelper
 #  TODO: Drop when adopted in cdbs
-CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper
+CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper (>=9.20141010)
 
 # Needed by upstream build
 #  * recent gyp needed to build using flock
 bdeps = binutils, openssl (>= $(ssl-minver)), pkg-config
 bdeps +=, bash-completion, curl, procps, zlib1g-dev, libicu-dev
 bdeps +=, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
+# Needed for tests
+bdeps +=, ca-certificates
+
 # needed by doctool-yaml.patch
-bdeps +=, node-yamlish
+bdeps +=, node-yamlish <!stage1>
 # needed by doc builder
-bdeps +=, node-marked
+bdeps +=, node-marked <!stage1>
 
 # Needed by upstream build and binary development package
 #  * recent libv8 because... FIXME (git commit eb490ef)
-deps = python, libssl-dev (>= $(ssl-minver))
-deps +=, libuv1-dev, ca-certificates
+deps = python, libssl1.0-dev (>= $(ssl-minver))
+deps +=, libuv1-dev
 
 CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps)
 CDBS_DEPENDS_nodejs-dev = $(deps)
+CDBS_RECOMMENDS_nodejs = ca-certificates
 CDBS_PROVIDES_nodejs = nodejs-abi-$(abi)
 
 # suppress checking binary files, to not upset dpkg-source
@@ -58,7 +62,7 @@
 destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
 destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
 destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
-destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
+destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),ppc))
 destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
 destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))
 
@@ -128,12 +132,11 @@
 export HOME = $(CURDIR)/test/tmp
 export FLAKY_TESTS = dontcare
 export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
-export CI_NATIVE_SUITES =
 export CI_JS_SUITES = message parallel sequential
 
 # keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
 exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
-DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci
+DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js
 
 # hardening gyp
 CXXFLAGS+=$(CPPFLAGS)
@@ -161,15 +164,23 @@
 	mv debian/nodejs/usr/bin/node debian/nodejs/usr/bin/nodejs
 	mv debian/nodejs/usr/share/man/man1/node.1 debian/nodejs/usr/share/man/man1/nodejs.1
 
+ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
 # remove *.json files from documentation
 binary-install/nodejs::
 	find debian/nodejs/usr/share/doc/nodejs -name *.json -delete
+endif
 
 pre-build::
 	mkdir -p $(HOME)
 
+ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
 build/nodejs::
 	make doc
+else
+# Stops the stage1 variant from breaking dh_installdocs
+build/nodejs::
+	mkdir -p out/doc/api
+endif
 
 # Provide dependency hints for reverse dependencies to consume
 CDBS_SUGGESTS_nodejs-dev = debhelper

## nodejs 4.8.2~dfsg

=== Makefile ===
--- 
+++ 
@@ -60,13 +60,18 @@
 # to check for changes.
 .PHONY: $(NODE_EXE) $(NODE_G_EXE)
 
+# The -r/-L check stops it recreating the link if it is already in place,
+# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
+# Without the check there is a race condition between the link being deleted
+# and recreated which can break the addons build when running test-ci
+# See comments on the build-addons target for some more info
 $(NODE_EXE): config.gypi out/Makefile
 	$(MAKE) -C out BUILDTYPE=Release V=$(V)
-	ln -fs out/Release/$(NODE_EXE) $@
+	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi
 
 $(NODE_G_EXE): config.gypi out/Makefile
 	$(MAKE) -C out BUILDTYPE=Debug V=$(V)
-	ln -fs out/Debug/$(NODE_EXE) $@
+	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
 
 out/Makefile: common.gypi deps/uv/uv.gyp deps/http_parser/http_parser.gyp deps/zlib/zlib.gyp deps/v8/build/toolchain.gypi deps/v8/build/features.gypi deps/v8/tools/gyp/v8.gyp node.gyp config.gypi
 	$(PYTHON) tools/gyp_node.py -f make
@@ -151,7 +156,7 @@
 #	Cannot use $(wildcard test/addons/*/) here, it's evaluated before
 #	embedded addons have been generated from the documentation.
 	@for dirname in test/addons/*/; do \
-		echo "\nBuilding addon $$PWD/$$dirname" ; \
+		printf "\nBuilding addon $$PWD/$$dirname\n" ; \
 		env MAKEFLAGS="-j1" $(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp \
 		        --loglevel=$(LOGLEVEL) rebuild \
 			--python="$(PYTHON)" \
@@ -194,12 +199,22 @@
 	$(PYTHON) tools/test.py -p tap --logfile test.tap \
 		--mode=release --flaky-tests=$(FLAKY_TESTS) \
 		$(TEST_CI_ARGS) $(CI_JS_SUITES)
+	# Clean up any leftover processes
+	PS_OUT=`ps awwx | grep Release/node | grep -v grep | awk '{print $$1}'`; \
+	if [ "$${PS_OUT}" ]; then \
+		echo $${PS_OUT} | $(XARGS) kill; exit 1; \
+	fi
 
 test-ci: LOGLEVEL := info
 test-ci: | build-addons
 	out/Release/cctest --gtest_output=tap:cctest.tap
 	$(PYTHON) tools/test.py -p tap --logfile test.tap --mode=release --flaky-tests=$(FLAKY_TESTS) \
 		$(TEST_CI_ARGS) $(CI_NATIVE_SUITES) $(CI_JS_SUITES)
+	# Clean up any leftover processes
+	PS_OUT=`ps awwx | grep Release/node | grep -v grep | awk '{print $$1}'`; \
+	if [ "$${PS_OUT}" ]; then \
+		echo $${PS_OUT} | $(XARGS) kill; exit 1; \
+	fi
 
 test-release: test-build
 	$(PYTHON) tools/test.py --mode=release
@@ -264,6 +279,11 @@
 
 test-v8-all: test-v8 test-v8-intl test-v8-benchmarks
 # runs all v8 tests
+
+# Google Analytics ID used for tracking API docs page views, empty
+# DOCS_ANALYTICS means no tracking scripts will be included in the
+# generated .html files
+DOCS_ANALYTICS ?=
 
 apidoc_sources = $(wildcard doc/api/*.md)
 apidocs_html = $(apidoc_dirs) $(apiassets) $(addprefix out/,$(apidoc_sources:.md=.html))
@@ -298,7 +318,8 @@
 	[ -x $(NODE) ] && $(NODE) $(gen-json) || node $(gen-json)
 
 # check if ./node is actually set, else use user pre-installed binary
-gen-html = tools/doc/generate.js --node-version=$(FULLVERSION) --format=html --template=doc/template.html $< > $@
+gen-html = tools/doc/generate.js --node-version=$(FULLVERSION) --format=html \
+			--template=doc/template.html --analytics=$(DOCS_ANALYTICS) $< > $@
 out/doc/api/%.html: doc/api/%.md
 	@[ -e tools/doc/node_modules/js-yaml/package.json ] || \
 		[ -e tools/eslint/node_modules/js-yaml/package.json ] || \
@@ -350,38 +371,3 @@
 endif # ifndef COMMIT
 ifneq ($(DISTTYPE),nightly)
 ifneq ($(DISTTYPE),next-nightly)
-$(error DISTTYPE is not release, custom, nightly or next-nightly)
-endif # ifneq ($(DISTTYPE),next-nightly)
-endif # ifneq ($(DISTTYPE),nightly)
-TAG=$(DISTTYPE)$(DATESTRING)$(COMMIT)
-endif # ifeq ($(DISTTYPE),custom)
-FULLVERSION=$(VERSION)-$(TAG)
-endif # ifeq ($(DISTTYPE),release)
-
-DISTTYPEDIR ?= $(DISTTYPE)
-RELEASE=$(shell sed -ne 's/\#define NODE_VERSION_IS_RELEASE \([01]\)/\1/p' src/node_version.h)
-PLATFORM=$(shell uname | tr '[:upper:]' '[:lower:]')
-NPMVERSION=v$(shell cat deps/npm/package.json | grep '"version"' | sed 's/^[^:]*: "\([^"]*\)",.*/\1/')
-
-UNAME_M=$(shell uname -m)
-ifeq ($(findstring x86_64,$(UNAME_M)),x86_64)
-DESTCPU ?= x64
-else
-ifeq ($(findstring ppc64,$(UNAME_M)),ppc64)
-DESTCPU ?= ppc64
-else
-ifeq ($(findstring ppc,$(UNAME_M)),ppc)
-DESTCPU ?= ppc
-else
-ifeq ($(findstring s390x,$(UNAME_M)),s390x)
-DESTCPU ?= s390x
-else
-ifeq ($(findstring s390,$(UNAME_M)),s390)
-DESTCPU ?= s390
-else
-ifeq ($(findstring arm,$(UNAME_M)),arm)
-DESTCPU ?= arm
-else
-ifeq ($(findstring aarch64,$(UNAME_M)),aarch64)
-DESTCPU ?= aarch64
-else

=== debian/changelog ===
nodejs (4.8.2~dfsg-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Fix dependency libssl-dev in d/rules
    Closes: #861178

 -- Andreas Tille <tille@debian.org>  Sat, 20 May 2017 10:37:20 +0200

nodejs (4.8.2~dfsg-1) unstable; urgency=medium

  * New upstream version 4.8.2~dfsg
  * Fix memory leak if certificate is revoked (introduced in 4.8.1)

 -- Jérémy Lal <kapouer@melix.org>  Tue, 04 Apr 2017 15:46:55 +0200

nodejs (4.8.1~dfsg-1) unstable; urgency=medium

  * New upstream version 4.8.1~dfsg
  * Update 2014_donotinclude_root_certs.patch to hard-code
    NODE_EXTRA_CA_CERTS to /etc/ssl/certs/ca-certificates.crt
    This is safer to maintain and safer to use since it disables
    that undocumented env var setting.
    Also expect extra ca tests to fail.
  * Add dnt_helper.js Expat license

 -- Jérémy Lal <kapouer@melix.org>  Wed, 22 Mar 2017 01:09:24 +0100

nodejs (4.7.2~dfsg-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Andreas Tille <tille@debian.org>  Wed, 22 Mar 2017 16:51:38 +0100

nodejs (4.7.2~dfsg-2) unstable; urgency=medium

  * Patch fixing openssl 1.1 client test failure (Closes: #855018)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 13 Feb 2017 12:00:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: nodejs
 Section: web
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>,
  Jonas Smedegaard <dr@jones.dk>
 Build-Depends: cdbs,
@@ -21,7 +20,7 @@
  node-yamlish <!stage1>,
  node-marked <!stage1>,
  python,
- libssl1.0-dev (>= 1.0.2),
+ libssl-dev (>= 1.0.2),
  libuv1-dev
 Standards-Version: 3.9.8
 Homepage: http://nodejs.org/

=== debian/rules ===
--- 
+++ 
@@ -62,7 +62,7 @@
 destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
 destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
 destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
-destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),ppc))
+destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
 destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
 destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))
